.TH "sic" "1" "$Date: 2000/07/31 22:33:41 $" "" "" 
.SH "NAME" 
sic \- text interface to the Internet Relay Chat system
.SH "SYNOPSIS" 
.PP 
\fBsic\fP [ \fB-c confdir\fP ] [ \fB-i ip\fP ] [ \fB-l logdir\fP ] [ \fB-n\fP ] [ \fB-r script\fP ] [ \fB-v\fP ]
.PP 
.SH "DESCRIPTION" 
.PP 
The \fIsic\fP program is a full screen, termcap based interface to the
Internet Relay Chat\&.  It can handle several concurrent connections,
through the use of virtual windows\&.
.PP 
.SH "OPTIONS" 
.PP 
.IP "\fB-c confdir\fP" 
This can be used to override the default
directory in which the configuration files are\&.  The default
is $SICDIR\&.
.IP "\fB-i ip\fP" 
This option instructs \fIsic\fP to use the given
address as the local address\&.  This is only useful for
multi-homed hosts\&.  The default is $SICIP\&.
.IP "\fB-l directory\fP" 
This option can be used to override the
default directory in which logfiles will be created\&.  The
default is $SICLOG\&.
.IP "\fB-n\fP" 
Normally, on startup \fIsic\fP will automatically
connect to the first server specified in the configuration\&.
This option can be used to start \fIsic\fP without initiation
any connection\&.
.IP "\fB-r filename\fP" 
If a filename is specified, the client
will read such file (within $SICDIR) and execute any command
specified in it\&.
.IP "\fB-v\fP" 
This will make \fIsic\fP print its version information\&.
.PP 
.SH "COPYRIGHT" 
.PP 
Copyright (C) 1997-2000 Christophe Kalt <kalt@stealth\&.net>
.PP 
.SH "FILES" 
.PP 
"$SICDIR/alias"
.br 
"$SICDIR/server"
.br 
"$SICDIR/top"
.br 
"$SICDIR/startup"
.br 
"$SICDIR/URLs"
.br 
"$SICDIR/irc"
.br 
"$SICDIR/EFnet"
.br 
"$SICDIR/Undernet"
.br 
"$SICDIR/DALnet"
.br 
.PP 
.SH "ENVIRONMENT VARIABLES" 
.PP 
The following environment variables are used by \fIsic\fP:
.PP 
.IP "\fBSICDIR\fP" 
The directory the configuration files are
located\&.  The default is $HOME/\&.sic\&.
.IP "\fBSICLOG\fP" 
The directory the log files should be created\&.
The default is $SICDIR/log\&.
.IP "\fBSICIP\fP" 
The IP address that should be used as the local
address\&.
.IP "\fBSICUSER\fP" 
The username to use when registering a
connection to an IRC server\&.  The default is $USER if it
exists, sicuser otherwise\&.
.IP "\fBSICNAME\fP" 
The real name to use when registering a
connection to an IRC server\&.  The default is "wasting time"\&.
.PP 
.SH "SEE ALSO" 
.PP 
sic-server(5) sic-alias(5)
.PP 
.SH "BUGS" 
.PP 
Bugs should be reported to the author\&.
.PP 
.SH "AUTHOR" 
.PP 
Christophe Kalt <kalt@stealth\&.net>
